diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.35/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.34/src/wifi/test/wifi-mac-ofdma-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/wifi-mac-ofdma-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -205,7 +205,7 @@
               return SU_TX;
             }
 
-          WifiMacQueueItem::QueueIteratorPair queueIt;
+          WifiMacQueueItem::ConstIterator queueIt;
           Ptr<WifiMacQueueItem> mpdu = m_apMac->GetQosTxop (AC_BE)->GetNextMpdu (peeked, m_txParams,
                                                                                  m_availableTime,
                                                                                  m_initialFrame, queueIt);
@@ -326,15 +326,28 @@
 {
 public:
   /**
+   * MU EDCA Parameter Set
+   */
+  struct MuEdcaParameterSet
+  {
+    uint8_t muAifsn;   //!< MU AIFS (0 to disable EDCA)
+    uint16_t muCwMin;  //!< MU CW min
+    uint16_t muCwMax;  //!< MU CW max
+    uint8_t muTimer;   //!< MU EDCA Timer in units of 8192 microseconds (0 not to use MU EDCA)
+  };
+
+  /**
    * Constructor
    * \param width the PHY channel bandwidth in MHz
    * \param dlType the DL MU ack sequence type
    * \param maxAmpduSize the maximum A-MPDU size in bytes
    * \param txopLimit the TXOP limit in microseconds
    * \param nPktsPerSta number of packets to send to/receive from each station
+   * \param muEdcaParameterSet the MU EDCA Parameter Set
    */
   OfdmaAckSequenceTest (uint16_t width, WifiAcknowledgment::Method dlType, uint32_t maxAmpduSize,
-                        uint16_t txopLimit, uint16_t nPktsPerSta);
+                        uint16_t txopLimit, uint16_t nPktsPerSta,
+                        MuEdcaParameterSet muEdcaParameterSet);
   virtual ~OfdmaAckSequenceTest ();
 
   /**
@@ -345,6 +358,13 @@
    */
   void L7Receive (std::string context, Ptr<const Packet> p, const Address &addr);
   /**
+   * Function to trace CW value used by the given station after the MU exchange
+   * \param staIndex the index of the given station
+   * \param oldCw the previous Contention Window value
+   * \param cw the current Contention Window value
+   */
+  void TraceCw (uint32_t staIndex, uint32_t oldCw, uint32_t cw);
+  /**
    * Callback invoked when FrameExchangeManager passes PSDUs to the PHY
    * \param context the context
    * \param psduMap the PSDU map
@@ -374,18 +394,24 @@
 
   uint16_t m_nStations;                      ///< number of stations
   NetDeviceContainer m_staDevices;           ///< stations' devices
+  Ptr<NetDevice> m_apDevice;                 ///< AP's device
   uint16_t m_channelWidth;                   ///< PHY channel bandwidth in MHz
   std::vector<FrameInfo> m_txPsdus;          ///< transmitted PSDUs
   WifiAcknowledgment::Method m_dlMuAckType;  ///< DL MU ack sequence type
   uint32_t m_maxAmpduSize;                   ///< maximum A-MPDU size in bytes
   uint16_t m_txopLimit;                      ///< TXOP limit in microseconds
   uint16_t m_nPktsPerSta;                    ///< number of packets to send to each station
+  MuEdcaParameterSet m_muEdcaParameterSet;   ///< MU EDCA Parameter Set
   uint16_t m_received;                       ///< number of packets received by the stations
+  uint16_t m_flushed;                        ///< number of DL packets flushed after DL MU PPDU
+  Time m_edcaDisabledStartTime;              ///< time when disabling EDCA started
+  std::vector<uint32_t> m_cwValues;          ///< CW used by stations after MU exchange
 };
 
 OfdmaAckSequenceTest::OfdmaAckSequenceTest (uint16_t width, WifiAcknowledgment::Method dlType,
                                             uint32_t maxAmpduSize, uint16_t txopLimit,
-                                            uint16_t nPktsPerSta)
+                                            uint16_t nPktsPerSta,
+                                            MuEdcaParameterSet muEdcaParameterSet)
   : TestCase ("Check correct operation of DL OFDMA acknowledgment sequences"),
     m_nStations (4),
     m_channelWidth (width),
@@ -393,7 +419,11 @@
     m_maxAmpduSize (maxAmpduSize),
     m_txopLimit (txopLimit),
     m_nPktsPerSta (nPktsPerSta),
-    m_received (0)
+    m_muEdcaParameterSet (muEdcaParameterSet),
+    m_received (0),
+    m_flushed (0),
+    m_edcaDisabledStartTime (Seconds (0)),
+    m_cwValues (std::vector<uint32_t> (m_nStations, 2))  // 2 is an invalid CW value
 {
 }
 
@@ -411,6 +441,17 @@
 }
 
 void
+OfdmaAckSequenceTest::TraceCw (uint32_t staIndex, uint32_t oldCw, uint32_t cw)
+{
+  if (m_cwValues.at (staIndex) == 2)
+    {
+      // store the first CW used after MU exchange (the last one may be used after
+      // the MU EDCA timer expired)
+      m_cwValues[staIndex] = cw;
+    }
+}
+
+void
 OfdmaAckSequenceTest::Transmit (std::string context, WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW)
 {
   // skip beacon frames and frames transmitted before 1.5s (association
@@ -423,18 +464,35 @@
                             Simulator::Now () + txDuration,
                             psduMap, txVector});
 
-      NS_LOG_INFO ("Sending " << psduMap.begin ()->second->GetHeader (0).GetTypeString ()
-                    << " #MPDUs " << psduMap.begin ()->second->GetNMpdus ()
-                    << " txDuration " << txDuration
-                    << " duration/ID " << psduMap.begin ()->second->GetHeader (0).GetDuration ()
-                    << " #TX PSDUs = " << m_txPsdus.size ());
+      for (const auto& psduPair : psduMap)
+        {
+          NS_LOG_INFO ("Sending " << psduPair.second->GetHeader (0).GetTypeString ()
+                        << " #MPDUs " << psduPair.second->GetNMpdus ()
+                        << " txDuration " << txDuration
+                        << " duration/ID " << psduPair.second->GetHeader (0).GetDuration ()
+                        << " #TX PSDUs = " << m_txPsdus.size ());
+        }
     }
 
-  // Flush the MAC queues of the stations after sending an HE TB PPDU containing QoS data
-  // frames, so that stations do not attempt to access the channel and the UL MU transmission
-  // is followed by a DL MU transmission
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB
-      && psduMap.begin ()->second->GetHeader (0).HasData ())
+  // Flush the MAC queue of the AP after sending a DL MU PPDU (no need for
+  // further transmissions)
+  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+    {
+      auto dev = DynamicCast<WifiNetDevice> (m_apDevice);
+      Ptr<WifiMacQueue> queue = DynamicCast<RegularWifiMac> (dev->GetMac ())->GetQosTxop (AC_BE)->GetWifiMacQueue ();
+      m_flushed = 0;
+      for (auto it = queue->begin (); it != queue->end (); )
+        {
+          auto tmp = it++;
+          if (!(*tmp)->IsInFlight ())
+            {
+              queue->Remove (tmp);
+              m_flushed++;
+            }
+        }
+    }
+  else if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB
+           && psduMap.begin ()->second->GetHeader (0).HasData ())
     {
       Mac48Address sender = psduMap.begin ()->second->GetAddr2 ();
 
@@ -444,11 +502,42 @@
 
           if (dev->GetAddress () == sender)
             {
-              DynamicCast<RegularWifiMac> (dev->GetMac ())->GetQosTxop (AC_BE)->GetWifiMacQueue ()->Flush ();
+              Ptr<QosTxop> qosTxop = DynamicCast<RegularWifiMac> (dev->GetMac ())->GetQosTxop (AC_BE);
+
+              if (m_muEdcaParameterSet.muTimer > 0 && m_muEdcaParameterSet.muAifsn > 0)
+                {
+                  // stations use worse access parameters, trace CW. MU AIFSN must be large
+                  // enough to avoid collisions between stations trying to transmit using EDCA
+                  // right after the UL MU transmission and the AP trying to send a DL MU PPDU
+                  qosTxop->TraceConnectWithoutContext ("CwTrace",
+                                                       MakeCallback (&OfdmaAckSequenceTest::TraceCw,
+                                                                     this).Bind (i));
+                }
+              else
+                {
+                  // there is no "protection" against collisions from stations, hence flush
+                  // their MAC queues after sending an HE TB PPDU containing QoS data frames,
+                  // so that the AP can send a DL MU PPDU
+                  qosTxop->GetWifiMacQueue ()->Flush ();
+                }
               break;
             }
         }
     }
+  else if (!txVector.IsMu () && psduMap.begin ()->second->GetHeader (0).IsBlockAck ()
+           && psduMap.begin ()->second->GetHeader (0).GetAddr2 () == m_apDevice->GetAddress ()
+           && m_muEdcaParameterSet.muTimer > 0 && m_muEdcaParameterSet.muAifsn == 0)
+    {
+      CtrlBAckResponseHeader blockAck;
+      psduMap.begin ()->second->GetPayload (0)->PeekHeader (blockAck);
+
+      if (blockAck.IsMultiSta ())
+        {
+          // AP is transmitting a multi-STA BlockAck and stations have to disable EDCA,
+          // record the starting time
+          m_edcaDisabledStartTime = Simulator::Now () + m_txPsdus.back ().endTx - m_txPsdus.back ().startTx;
+        }
+    }
 }
 
 void
@@ -706,6 +795,8 @@
     }
   NS_TEST_EXPECT_MSG_GT (navEnd, m_txPsdus[11].endTx, "Duration/ID of the DL MU PPDU cannot be zero");
 
+  std::size_t nTxPsdus = 0;
+
   if (m_dlMuAckType == WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE)
     {
       /*
@@ -804,6 +895,7 @@
           navEnd = m_txPsdus[17].endTx + m_txPsdus[17].psduMap[SU_STA_ID]->GetDuration ();
           NS_TEST_EXPECT_MSG_GT_OR_EQ (navEnd + tolerance, m_txPsdus[18].endTx, "Duration/ID in the 3rd BlockAckReq is too short");
         }
+      nTxPsdus = 19;
     }
   else if (m_dlMuAckType == WifiAcknowledgment::DL_MU_TF_MU_BAR)
     {
@@ -886,6 +978,8 @@
       NS_TEST_EXPECT_MSG_GT_OR_EQ (navEnd + tolerance, m_txPsdus[14].endTx, "Duration/ID in the MU-BAR Trigger Frame is too short");
       NS_TEST_EXPECT_MSG_GT_OR_EQ (navEnd + tolerance, m_txPsdus[15].endTx, "Duration/ID in the MU-BAR Trigger Frame is too short");
       NS_TEST_EXPECT_MSG_GT_OR_EQ (navEnd + tolerance, m_txPsdus[16].endTx, "Duration/ID in the MU-BAR Trigger Frame is too short");
+
+      nTxPsdus = 17;
     }
   else if (m_dlMuAckType == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
@@ -955,9 +1049,42 @@
       NS_TEST_EXPECT_MSG_LT (tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
       NS_TEST_EXPECT_MSG_LT (tStart, tEnd + sifs + tolerance, "Block Ack in HE TB PPDU sent too late");
       NS_TEST_EXPECT_MSG_GT_OR_EQ (navEnd + tolerance, m_txPsdus[15].endTx, "Duration/ID in the DL MU PPDU is too short");
+
+      nTxPsdus = 16;
+    }
+
+  NS_TEST_EXPECT_MSG_EQ (m_received, m_nPktsPerSta * m_nStations - m_flushed,
+                         "Not all DL packets have been received");
+
+  if (m_muEdcaParameterSet.muTimer > 0 && m_muEdcaParameterSet.muAifsn == 0)
+    {
+      // EDCA disabled, find the first PSDU transmitted by a station not in an
+      // HE TB PPDU and check that it was not transmitted before the MU EDCA
+      // timer expired
+      for (std::size_t i = nTxPsdus; i < m_txPsdus.size (); ++i)
+        {
+          if (m_txPsdus[i].psduMap.size () == 1
+              && m_txPsdus[i].psduMap.begin ()->second->GetHeader (0).GetAddr2 () != m_apDevice->GetAddress ()
+              && !m_txPsdus[i].txVector.IsUlMu ())
+            {
+              NS_TEST_EXPECT_MSG_GT_OR_EQ (m_txPsdus[i].startTx.GetMicroSeconds (),
+                                           m_edcaDisabledStartTime.GetMicroSeconds ()
+                                           + m_muEdcaParameterSet.muTimer * 8192,
+                                           "A station transmitted before the MU EDCA timer expired");
+              break;
+            }
+        }
+    }
+  else if (m_muEdcaParameterSet.muTimer > 0 && m_muEdcaParameterSet.muAifsn > 0)
+    {
+      // stations used worse access parameters after successful UL MU transmission
+      for (const auto& cwValue : m_cwValues)
+        {
+          NS_TEST_EXPECT_MSG_EQ ((cwValue == 2 || cwValue >= m_muEdcaParameterSet.muCwMin),
+                                 true, "A station did not set the correct MU CW min");
+        }
     }
 
-  NS_TEST_EXPECT_MSG_EQ (m_received, m_nPktsPerSta * m_nStations, "Not all packets have been received");
   m_txPsdus.clear ();
 }
 
@@ -1003,6 +1130,25 @@
     }
   phy.Set ("ChannelWidth", UintegerValue (m_channelWidth));
 
+  Config::SetDefault ("ns3::HeConfiguration::MuBeAifsn",
+                      UintegerValue (m_muEdcaParameterSet.muAifsn));
+  Config::SetDefault ("ns3::HeConfiguration::MuBeCwMin",
+                      UintegerValue (m_muEdcaParameterSet.muCwMin));
+  Config::SetDefault ("ns3::HeConfiguration::MuBeCwMax",
+                      UintegerValue (m_muEdcaParameterSet.muCwMax));
+  Config::SetDefault ("ns3::HeConfiguration::BeMuEdcaTimer",
+                      TimeValue (MicroSeconds (8192 * m_muEdcaParameterSet.muTimer)));
+  // MU EDCA timers must be either all null or all non-null
+  Config::SetDefault ("ns3::HeConfiguration::BkMuEdcaTimer",
+                      TimeValue (MicroSeconds (8192 * m_muEdcaParameterSet.muTimer)));
+  Config::SetDefault ("ns3::HeConfiguration::ViMuEdcaTimer",
+                      TimeValue (MicroSeconds (8192 * m_muEdcaParameterSet.muTimer)));
+  Config::SetDefault ("ns3::HeConfiguration::VoMuEdcaTimer",
+                      TimeValue (MicroSeconds (8192 * m_muEdcaParameterSet.muTimer)));
+
+  // increase MSDU lifetime so that it does not expire before the MU EDCA timer ends
+  Config::SetDefault ("ns3::WifiMacQueue::MaxDelay", TimeValue (Seconds (2)));
+
   WifiHelper wifi;
   wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
@@ -1027,11 +1173,10 @@
   mac.SetMultiUserScheduler ("ns3::TestMultiUserScheduler");
   mac.SetAckManager ("ns3::WifiDefaultAckManager", "DlMuAckSequenceType", EnumValue (m_dlMuAckType));
 
-  NetDeviceContainer apDevices;
-  apDevices = wifi.Install (phy, mac, wifiApNode);
+  m_apDevice = wifi.Install (phy, mac, wifiApNode).Get (0);
 
   // Assign fixed streams to random variables in use
-  streamNumber += wifi.AssignStreams (apDevices, streamNumber);
+  streamNumber += wifi.AssignStreams (NetDeviceContainer (m_apDevice), streamNumber);
   streamNumber += wifi.AssignStreams (m_staDevices, streamNumber);
 
   MobilityHelper mobility;
@@ -1056,7 +1201,7 @@
       dev = DynamicCast<WifiNetDevice> (m_staDevices.Get (i));
       dev->GetMac ()->SetAttribute ("BE_MaxAmpduSize", UintegerValue (m_maxAmpduSize));
     }
-  dev = DynamicCast<WifiNetDevice> (apDevices.Get (0));
+  dev = DynamicCast<WifiNetDevice> (m_apDevice);
   dev->GetMac ()->SetAttribute ("BE_MaxAmpduSize", UintegerValue (m_maxAmpduSize));
 
   PointerValue ptr;
@@ -1073,7 +1218,7 @@
   for (uint16_t i = 0; i < m_nStations; i++)
     {
       PacketSocketAddress socket;
-      socket.SetSingleDevice (apDevices.Get (0)->GetIfIndex ());
+      socket.SetSingleDevice (m_apDevice->GetIfIndex ());
       socket.SetPhysicalAddress (m_staDevices.Get (i)->GetAddress ());
       socket.SetProtocol (1);
 
@@ -1111,7 +1256,7 @@
     {
       PacketSocketAddress socket;
       socket.SetSingleDevice (m_staDevices.Get (i)->GetIfIndex ());
-      socket.SetPhysicalAddress (apDevices.Get (0)->GetAddress ());
+      socket.SetPhysicalAddress (m_apDevice->GetAddress ());
       socket.SetProtocol (1);
 
       // the first client application generates two packets in order
@@ -1174,12 +1319,19 @@
 WifiMacOfdmaTestSuite::WifiMacOfdmaTestSuite ()
   : TestSuite ("wifi-mac-ofdma", UNIT)
 {
-  AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE, 10000, 5440, 15), TestCase::QUICK);
-  AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_AGGREGATE_TF, 10000, 5440, 15), TestCase::QUICK);
-  AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_TF_MU_BAR, 10000, 5440, 15), TestCase::QUICK);
-  AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE, 10000, 0, 15), TestCase::QUICK);
-  AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_AGGREGATE_TF, 10000, 0, 15), TestCase::QUICK);
-  AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_TF_MU_BAR, 10000, 0, 15), TestCase::QUICK);
+  using MuEdcaParams = std::initializer_list<OfdmaAckSequenceTest::MuEdcaParameterSet>;
+
+  for (auto& muEdcaParameterSet : MuEdcaParams {{0, 0, 0, 0}         /* no MU EDCA */,
+                                                {0, 127, 2047, 100}  /* EDCA disabled */,
+                                                {10, 127, 2047, 100} /* worse parameters */})
+    {
+      AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE, 10000, 5440, 15, muEdcaParameterSet), TestCase::QUICK);
+      AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_AGGREGATE_TF, 10000, 5440, 15, muEdcaParameterSet), TestCase::QUICK);
+      AddTestCase (new OfdmaAckSequenceTest (20, WifiAcknowledgment::DL_MU_TF_MU_BAR, 10000, 5440, 15, muEdcaParameterSet), TestCase::QUICK);
+      AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE, 10000, 0, 15, muEdcaParameterSet), TestCase::QUICK);
+      AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_AGGREGATE_TF, 10000, 0, 15, muEdcaParameterSet), TestCase::QUICK);
+      AddTestCase (new OfdmaAckSequenceTest (40, WifiAcknowledgment::DL_MU_TF_MU_BAR, 10000, 0, 15, muEdcaParameterSet), TestCase::QUICK);
+    }
 }
 
 static WifiMacOfdmaTestSuite g_wifiMacOfdmaTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/wifi-mac-queue-test.cc ns-3.35/src/wifi/test/wifi-mac-queue-test.cc
--- ns-3.34/src/wifi/test/wifi-mac-queue-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/wifi-mac-queue-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -53,7 +53,7 @@
 void
 WifiMacQueueDropOldestTest::DoRun ()
 {
-  auto wifiMacQueue = CreateObject<WifiMacQueue> ();
+  auto wifiMacQueue = CreateObject<WifiMacQueue> (AC_BE);
   wifiMacQueue->SetMaxSize (QueueSize ("5p"));
   wifiMacQueue->SetAttribute ("DropPolicy", EnumValue (WifiMacQueue::DROP_OLDEST));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.35/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.34/src/wifi/test/wifi-phy-ofdma-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/wifi-phy-ofdma-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -3232,7 +3232,7 @@
   void RunOne (bool setupBa);
 
   /**
-   * Replace the AP's MacLow callback on its PHY's ReceiveOkCallback
+   * Replace the AP's callback on its PHY's ReceiveOkCallback
    * by the ReceiveOkCallbackAtAp method.
    */
   void ReplaceReceiveOkCallbackOfAp (void);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/wifi-phy-reception-test.cc ns-3.35/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.34/src/wifi/test/wifi-phy-reception-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/wifi-phy-reception-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -19,11 +19,20 @@
  */
 
 #include "ns3/log.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/config.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/packet-socket-client.h"
+#include "ns3/packet-socket-helper.h"
+#include "ns3/packet-socket-server.h"
 #include "ns3/test.h"
 #include "ns3/double.h"
 #include "ns3/pointer.h"
 #include "ns3/rng-seed-manager.h"
 #include "ns3/spectrum-wifi-helper.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-spectrum-value-helper.h"
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/nist-error-rate-model.h"
@@ -2345,6 +2354,206 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Unsupported Modulation Reception Test
+ * This test creates a mixed network, in which an HE STA and a VHT
+ * STA are associated to an HE AP and send uplink traffic. In the
+ * simulated deployment the VHT STA's backoff will expire while the
+ * HE STA is sending a packet, and the VHT STA will access the
+ * channel anyway. This happens because the HE STA is using an HeMcs
+ * that the VHT STA is not able to demodulate: the VHT STA will
+ * correctly stop listening to the HE packet, but it will not update
+ * its InterferenceHelper with the HE packet. Later on, this leads to
+ * the STA wrongly assuming the medium is available when its back-off
+ * expires in the middle of the HE packet. We detect that this is
+ * happening by looking at the reason why the AP is failing to decode
+ * the preamble from the VHT STA's transmission: if the reason is
+ * that it's in RX already, the test fails. The test is based on
+ * wifi-txop-test.cc.
+*/
+class TestUnsupportedModulationReception : public TestCase
+{
+public:
+  /**
+   * Constructor
+   */
+  TestUnsupportedModulationReception ();
+  virtual ~TestUnsupportedModulationReception ();
+
+  /**
+   * Callback invoked when PHY drops an incoming packet
+   * \param context the context
+   * \param packet the packet that was dropped
+   * \param reason the reason the packet was dropped
+   */
+  void Dropped (std::string context, Ptr<const Packet> packet, WifiPhyRxfailureReason reason);
+  /**
+   * Check correctness of transmitted frames
+   */
+  void CheckResults (void);
+
+private:
+  void DoRun (void) override;
+  uint16_t m_dropped; ///< number of packets dropped by the AP because it was already receiving
+};
+
+TestUnsupportedModulationReception::TestUnsupportedModulationReception ()
+  : TestCase ("Check correct behavior when a STA is receiving a transmission using an unsupported modulation"),
+    m_dropped (0)
+{
+}
+
+TestUnsupportedModulationReception::~TestUnsupportedModulationReception ()
+{
+}
+
+void
+TestUnsupportedModulationReception::Dropped (std::string context, Ptr<const Packet> packet,
+                                             WifiPhyRxfailureReason reason)
+{
+  // Print if the test is executed through test-runner
+  if (reason == RXING)
+    {
+      std::cout << "Dropped a packet because already receiving" << std::endl;
+      m_dropped++;
+    }
+}
+
+void
+TestUnsupportedModulationReception::DoRun (void)
+{
+  uint16_t m_nStations = 2; ///< number of stations
+  NetDeviceContainer m_staDevices; ///< container for stations' NetDevices
+  NetDeviceContainer m_apDevices; ///< container for AP's NetDevice
+
+  // RngSeedManager::SetSeed (1);
+  // RngSeedManager::SetRun (40);
+  int64_t streamNumber = 100;
+
+  NodeContainer wifiApNode;
+  wifiApNode.Create (1);
+
+  NodeContainer wifiStaNodes;
+  wifiStaNodes.Create (m_nStations);
+
+  Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel> ();
+  Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel> ();
+  spectrumChannel->AddPropagationLossModel (lossModel);
+  Ptr<ConstantSpeedPropagationDelayModel> delayModel =
+      CreateObject<ConstantSpeedPropagationDelayModel> ();
+  spectrumChannel->SetPropagationDelayModel (delayModel);
+
+  SpectrumWifiPhyHelper phy;
+  phy.SetChannel (spectrumChannel);
+
+  Config::SetDefault ("ns3::WifiRemoteStationManager::RtsCtsThreshold", UintegerValue (65535));
+
+  WifiHelper wifi;
+  wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
+
+  WifiMacHelper mac;
+  mac.SetType ("ns3::StaWifiMac", "QosSupported", BooleanValue (true), "Ssid",
+               SsidValue (Ssid ("non-existent-ssid")));
+
+  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+  m_staDevices.Add (wifi.Install (phy, mac, wifiStaNodes.Get (0)));
+  wifi.SetStandard (WIFI_STANDARD_80211ac);
+  m_staDevices.Add (wifi.Install (phy, mac, wifiStaNodes.Get (1)));
+
+  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+  mac.SetType ("ns3::ApWifiMac", "QosSupported", BooleanValue (true), "Ssid",
+               SsidValue (Ssid ("wifi-backoff-ssid")), "BeaconInterval",
+               TimeValue (MicroSeconds (102400)), "EnableBeaconJitter", BooleanValue (false));
+
+  m_apDevices = wifi.Install (phy, mac, wifiApNode);
+
+  // schedule association requests at different times
+  Time init = MilliSeconds (100);
+  Ptr<WifiNetDevice> dev;
+
+  for (uint16_t i = 0; i < m_nStations; i++)
+    {
+      dev = DynamicCast<WifiNetDevice> (m_staDevices.Get (i));
+      Simulator::Schedule (init + i * MicroSeconds (102400), &WifiMac::SetSsid, dev->GetMac (),
+                           Ssid ("wifi-backoff-ssid"));
+    }
+
+  // Assign fixed streams to random variables in use
+  wifi.AssignStreams (m_apDevices, streamNumber);
+
+  MobilityHelper mobility;
+  Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator> ();
+
+  positionAlloc->Add (Vector (0.0, 0.0, 0.0));
+  positionAlloc->Add (Vector (1.0, 0.0, 0.0));
+  positionAlloc->Add (Vector (0.0, 1.0, 0.0));
+  positionAlloc->Add (Vector (-1.0, 0.0, 0.0));
+  mobility.SetPositionAllocator (positionAlloc);
+
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (wifiApNode);
+  mobility.Install (wifiStaNodes);
+
+  // set the TXOP limit on BE AC
+  dev = DynamicCast<WifiNetDevice> (m_apDevices.Get (0));
+  PointerValue ptr;
+  dev->GetMac ()->GetAttribute ("BE_Txop", ptr);
+
+  PacketSocketHelper packetSocket;
+  packetSocket.Install (wifiApNode);
+  packetSocket.Install (wifiStaNodes);
+
+  // UL Traffic
+  for (uint16_t i = 0; i < m_nStations; i++)
+    {
+      PacketSocketAddress socket;
+      socket.SetSingleDevice (m_staDevices.Get (0)->GetIfIndex ());
+      socket.SetPhysicalAddress (m_apDevices.Get (0)->GetAddress ());
+      socket.SetProtocol (1);
+      Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient> ();
+      client->SetAttribute ("PacketSize", UintegerValue (1500));
+      client->SetAttribute ("MaxPackets", UintegerValue (200));
+      client->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
+      client->SetRemote (socket);
+      wifiStaNodes.Get (i)->AddApplication (client);
+      client->SetStartTime (MicroSeconds (400000));
+      client->SetStopTime (Seconds (1.0));
+      Ptr<PacketSocketClient> legacyStaClient = CreateObject<PacketSocketClient> ();
+      legacyStaClient->SetAttribute ("PacketSize", UintegerValue (1500));
+      legacyStaClient->SetAttribute ("MaxPackets", UintegerValue (200));
+      legacyStaClient->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
+      legacyStaClient->SetRemote (socket);
+      wifiStaNodes.Get (i)->AddApplication (legacyStaClient);
+      legacyStaClient->SetStartTime (MicroSeconds (400000));
+      legacyStaClient->SetStopTime (Seconds (1.0));
+      Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer> ();
+      server->SetLocal (socket);
+      wifiApNode.Get (0)->AddApplication (server);
+      server->SetStartTime (Seconds (0.0));
+      server->SetStopTime (Seconds (1.0));
+    }
+
+  // Trace dropped packets
+  Config::Connect ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyRxDrop",
+                   MakeCallback (&TestUnsupportedModulationReception::Dropped, this));
+
+  Simulator::Stop (Seconds (1));
+  Simulator::Run ();
+
+  CheckResults ();
+
+  Simulator::Destroy ();
+}
+
+void
+TestUnsupportedModulationReception::CheckResults (void)
+{
+  NS_TEST_EXPECT_MSG_EQ (m_dropped, 0, "Dropped some packets unexpectedly");
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief wifi PHY reception Test Suite
  */
 class WifiPhyReceptionTestSuite : public TestSuite
@@ -2361,6 +2570,7 @@
   AddTestCase (new TestSimpleFrameCaptureModel, TestCase::QUICK);
   AddTestCase (new TestPhyHeadersReception, TestCase::QUICK);
   AddTestCase (new TestAmpduReception, TestCase::QUICK);
+  AddTestCase (new TestUnsupportedModulationReception (), TestCase::QUICK);
 }
 
 static WifiPhyReceptionTestSuite wifiPhyReceptionTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/wscript ns-3.35/src/wifi/wscript
--- ns-3.34/src/wifi/wscript	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/wscript	2021-10-01 13:26:48.000000000 -0700
@@ -17,6 +17,7 @@
         'model/non-ht/dsss-error-rate-model.cc',
         'model/table-based-error-rate-model.cc',
         'model/interference-helper.cc',
+        'model/wifi-phy-common.cc',
         'model/yans-wifi-phy.cc',
         'model/yans-wifi-channel.cc',
         'model/spectrum-wifi-phy.cc',
@@ -98,6 +99,7 @@
         'model/vht/vht-operation.cc',
         'model/non-ht/dsss-parameter-set.cc',
         'model/edca-parameter-set.cc',
+        'model/he/mu-edca-parameter-set.cc',
         'model/he/he-capabilities.cc',
         'model/frame-capture-model.cc',
         'model/simple-frame-capture-model.cc',
@@ -261,6 +263,7 @@
         'model/vht/vht-operation.h',
         'model/non-ht/dsss-parameter-set.h',
         'model/edca-parameter-set.h',
+        'model/he/mu-edca-parameter-set.h',
         'model/he/he-capabilities.h',
         'model/frame-capture-model.h',
         'model/simple-frame-capture-model.h',
